// Maze Engine
// 2004 Andrei R. Thomaz
// andreithomaz@bol.com.br
//
// www.rgbdesigndigital.com.br
//
// Line.as
// Every segment in the maze is represented by a Line object.
//

class Line {
      var x1:Number;
      var y1:Number;
      var x2:Number;
      var y2:Number;
      var nType:Number = 0;
      
      var numConnections:Number = 0;
      var listConnections:Array;    
      
      static var Vertical:Number = 1;
      static var Horizontal:Number = 2;
      static var Tolerance:Number = 10;
      static var Beginning:Boolean = true;
      static var End:Boolean = false;
      
      
      
      function Line(nx1:Number, ny1:Number, nx2:Number, ny2:Number) {        
          x1 = nx1;
          y1 = ny1;
          x2 = nx2;
          y2 = ny2;
          
          nType = ((nx1 == nx2) ? Line.Vertical : Line.Horizontal );
          
          listConnections = new Array(6);
      }
      
      function addConnection( point:Boolean, mov:Number, Line:Number, point_destiny_line:Boolean)
      {
          var newConnection:Connection = new Connection(point, mov, Line, point_destiny_line);
          listConnections[numConnections++] = newConnection;
      }
      
      function InTheBeginning(x, y)
      {
          if (nType == Line.Horizontal)
              return ((x >= (x1 - Line.Tolerance)) && (x <= (x1 + Line.Tolerance)));
          else
              return ((y >= (y1 - Line.Tolerance)) && (y <= (y1 + Line.Tolerance)));
      }
      
      function InTheEnd(x, y)
      {
          if (nType == Line.Horizontal)
              return ((x >= (x2 - Line.Tolerance)) && (x <= (x2 + Line.Tolerance)));
          else
              return ((y >= (y2 - Line.Tolerance)) && (y <= (y2 + Line.Tolerance)));
      }
}








