class Position {

    // the movieclip with the object in the screen
    var mcMovie:MovieClip;
    var x:Number = 0;
    var y:Number = 0;
    var nLine:Number = -1;
    var nDirection:Number = 1;
    var bBeginning:Boolean = true; 
    var bAutomatic:Boolean = false;    // if the connections must be done
                                       // automatically (for characters 
                                       // controlled by the computer) or
                                       // not (in the case of characters
                                       // moved by the user)
	
    static var maze:Array;
    private static var Step:Number = 5;
    
	  private static var bMazeDone:Boolean = false;

    function Position(strMovie:String, line:Number, beginning:Boolean,
               direction:Number, automatic:Boolean)
      {
          if (!Position.bMazeDone)
             createMaze();

          mcMovie = _root.attachMovie(strMovie,"_"+strMovie,10);
          if (beginning == Line.Beginning) {
            x = mcMovie._x = maze[line].x1;
            y = mcMovie._y = maze[line].y1;
          }
          else {
            x = mcMovie._x = maze[line].x2;
            y = mcMovie._y = maze[line].y2;
          }
          nLine = line;
          nDirection = direction;
          bBeginning = beginning;
          bAutomatic = automatic;
      }									
      
      function MakeConnection(connection:Connection)
      {
          nLine = connection.nLine;
          if (connection.bPointDestinyLine == Line.Beginning) {
              x = maze[nLine].x1;
              y = maze[nLine].y1;
          }
          else if (connection.bPointDestinyLine == Line.End) {
              x = maze[nLine].x2;
              y = maze[nLine].y2;
          }
          nDirection = 0;
      }


    function MakeConnectionAutoBeginning()
    {
        var nConnection:Number;
        for (;;) {
            nConnection = Math.round(Math.random()*maze[nLine].numConnections)-1;
            if (maze[nLine].listConnections[nConnection].ponto_linha == Line.Beginning) {
                nDirection = maze[nLine].listConnections[nConnection].nMovement;
                nLine = maze[nLine].listConnections[nConnection].nLine;
                bBeginning = maze[nLine].listConnections[nConnection].bPointDestinyLine;
                return;
            }
        } 
    }               

    function MakeConnectionAutoEnd()
    {
        var nConnection:Number;
        for (;;) {
            nConnection = Math.round(Math.random()*maze[nLine].numConnections)-1;
            if (maze[nLine].listConnections[nConnection].ponto_linha == Line.End) {
                nDirection = maze[nLine].listConnections[nConnection].nMovement;
                nLine = maze[nLine].listConnections[nConnection].nLine;
                bBeginning = maze[nLine].listConnections[nConnection].bPointDestinyLine;
                return;
            }
        } 
    }               

    function Up() 
    {
        trace("function Up()");
    
        var actualLine:Line = maze[nLine];
        var n:Number;
        var connection:Connection;
        
        if (actualLine.nType == Line.Vertical && y > actualLine.y1) {
            trace("moving up...");
            y -= Position.Step;
            if (y < actualLine.y1)
                y = actualLine.y1;
            updateMovie();
        }
        else {
            if (bAutomatic) {
                MakeConnectionAutoBeginning();
                return;
            }
            trace("looking for connection...");
            for (n=0; n < actualLine.numConnections; n++) {                
                connection = actualLine.listConnections[n];
                if (connection.nMovement == Direction.Up) {
                    if (actualLine.InTheBeginning(x,y) && (connection.bPoint == Line.Beginning)) {
                        trace("connection found");
                        MakeConnection(connection);
                        return;
                    }
                    else if (actualLine.InTheEnd(x,y) && (connection.bPoint == Line.End)) {
                        trace("connection found");
                        MakeConnection(connection);
                        return;
                    }
                }
            }
            trace("no connection found");
            nDirection = 0;
        }
    }                 

    function Down() 
    {
        trace("function Down()");
        
        var actualLine:Line = maze[nLine];
        var n:Number;
        var connection:Connection;
        
        if (actualLine.nType == Line.Vertical && y < actualLine.y2) {
            trace("moving down...");
            y += Position.Step;
            updateMovie();
        }
        else {
            if (bAutomatic) {
                MakeConnectionAutoEnd();
                return;
            } 
            
            trace("looking for connection...");
            trace("line: " + nLine);
            trace("connections: " + actualLine.numConnections);
            for (n=0; n < actualLine.numConnections; n++) {
                connection = actualLine.listConnections[n];
                if (connection.nMovement == Direction.Down) {
                    if (actualLine.InTheBeginning(x,y) && (connection.bPoint == Line.Beginning)) {
                        trace("connection found");
                        MakeConnection(connection);
                        return;
                    }
                    else if (actualLine.InTheEnd(x,y) && (connection.bPoint == Line.End)) {  
                        trace("connection found");
                        MakeConnection(connection);
                        return;
                    }
                }
            }
            trace("no connection found");
            nDirection = 0;
        }
    } 

    function Left() 
    {
        trace("function Left()");
    
        var actualLine = maze[nLine];
        var n;
        var connection;
        
        if (actualLine.nType == Line.Horizontal && x > actualLine.x1) {
           trace("moving left...");
           x -= Position.Step;
           updateMovie();
        }
        else {
            if (bAutomatic) {
               MakeConnectionAutoBeginning();
               return;
            }
            
            trace("looking for connection...");
            for (n=0; n < actualLine.numConnections; n++) {
                connection = actualLine.listConnections[n];
                
                if (connection.nMovement == Direction.Left) {
                   if (actualLine.InTheBeginning(x,y) && (connection.bPoint == Line.Beginning)) {
                      trace("connection found");
                      MakeConnection(connection);
                      return;
                   }
                   else if (actualLine.InTheEnd(x,y) && (connection.bPoint == Line.End)) {
                       trace("connection found");
                       MakeConnection(connection);
                       return;
                   }
               }
            }
            trace("no connection found");
            nDirection = 0;
        }
    }               

		function Right() 
    {
    	trace("function Right()");
        
        var actualLine:Line = maze[nLine];
        var n:Number;
        var connection:Connection;
        
        if ((actualLine.nType == Line.Horizontal) && (x < actualLine.x2)) {
           trace("moving right...");
        	x += Position.Step;
            updateMovie();
        }
        else {
            if (bAutomatic) {
                MakeConnectionAutoEnd();
                return;
            }
            
            trace("looking for connection...");
            for (n=0; n < actualLine.numConnections; n++) {
                connection = actualLine.listConnections[n];
                if (connection.nMovement == Direction.Right) {
                   if (actualLine.InTheBeginning(x,y) && (connection.bPoint == Line.Beginning)) {
                      trace("connection found");
                      MakeConnection(connection);
                      return;
                   }
                   else if (actualLine.InTheEnd(x,y) && (connection.bPoint == Line.End)) {
                       trace("connection found");
                       MakeConnection(connection);
                       return;
                   }
                }   
            }       
            trace("no connection found");
            nDirection = 0;
        }          
    }                   

		function updateMovie() 
    {        
			mcMovie._x = x;
        mcMovie._y = y;
    }   
      
    private function createMaze()
    {
        maze = new Array(12);

        maze[0] = new Line(0,0,2,0);
        maze[0].addConnection(Line.Beginning, Direction.Down, 2, Line.Beginning);
        maze[0].addConnection(Line.End, Direction.Down, 3, Line.Beginning);
        maze[0].addConnection(Line.End, Direction.Right, 1, Line.Beginning);

        maze[1] = new Line(2,0,4,0);
        maze[1].addConnection(Line.Beginning, Direction.Left, 0, Line.End);
        maze[1].addConnection(Line.Beginning, Direction.Down, 3, Line.Beginning);
        maze[1].addConnection(Line.End, Direction.Down, 4, Line.Beginning);

        maze[2] = new Line(0,0,0,2);
        maze[2].addConnection(Line.Beginning, Direction.Right, 0, Line.Beginning);
        maze[2].addConnection(Line.End, Direction.Right, 5, Line.Beginning);
        maze[2].addConnection(Line.End, Direction.Down, 7, Line.Beginning);

        maze[3] = new Line(2,0,2,2);
        maze[3].addConnection(Line.Beginning, Direction.Left, 0, Line.End);
        maze[3].addConnection(Line.Beginning, Direction.Right, 1, Line.Beginning);
        maze[3].addConnection(Line.End, Direction.Right, 6, Line.Beginning);
        maze[3].addConnection(Line.End, Direction.Left, 5, Line.End);
        maze[3].addConnection(Line.End, Direction.Down, 8, Line.Beginning);

        maze[4] = new Line(4,0,4,2);
        maze[4].addConnection(Line.Beginning, Direction.Left, 1, Line.End);
        maze[4].addConnection(Line.End, Direction.Left, 6, Line.End);
        maze[4].addConnection(Line.End, Direction.Down, 9, Line.Beginning);

        maze[5] = new Line(0,2,2,2);
        maze[5].addConnection(Line.Beginning, Direction.Down, 7, Line.Beginning);
        maze[5].addConnection(Line.Beginning, Direction.Up, 2, Line.End);
        maze[5].addConnection(Line.End, Direction.Right, 6, Line.Beginning);
        maze[5].addConnection(Line.End, Direction.Up, 3, Line.End);
        maze[5].addConnection(Line.End, Direction.Down, 8, Line.Beginning);

        maze[6] = new Line(2,2,4,2);
        maze[6].addConnection(Line.Beginning, Direction.Down, 8, Line.Beginning);
        maze[6].addConnection(Line.Beginning, Direction.Left, 5, Line.End);
        maze[6].addConnection(Line.Beginning, Direction.Up, 3, Line.End);
        maze[6].addConnection(Line.End, Direction.Up, 4, Line.End);
        maze[6].addConnection(Line.End, Direction.Down, 9, Line.Beginning);

        maze[7] = new Line(0,2,0,4);
        maze[7].addConnection(Line.Beginning, Direction.Right, 5, Line.Beginning);
        maze[7].addConnection(Line.Beginning, Direction.Up, 2, Line.End);
        maze[7].addConnection(Line.End, Direction.Right, 10, Line.Beginning);

        maze[8] = new Line(2,2,2,4);
        maze[8].addConnection(Line.Beginning, Direction.Left, 5, Line.End);
        maze[8].addConnection(Line.Beginning, Direction.Right, 6, Line.Beginning);
        maze[8].addConnection(Line.Beginning, Direction.Up, 3, Line.End);
        maze[8].addConnection(Line.End, Direction.Left, 10, Line.End);
        maze[8].addConnection(Line.End, Direction.Right, 11, Line.Beginning);

        maze[9] = new Line(4,2,4,4);
        maze[9].addConnection(Line.Beginning, Direction.Left, 6, Line.End);
        maze[9].addConnection(Line.Beginning, Direction.Up, 4, Line.End);
        maze[9].addConnection(Line.End, Direction.Left, 11, Line.End);

        maze[10] = new Line(0,4,2,4);
        maze[10].addConnection(Line.Beginning, Direction.Up, 7, Line.End);
        maze[10].addConnection(Line.End, Direction.Up, 8, Line.End);
        maze[10].addConnection(Line.End, Direction.Right, 11, Line.Beginning);

        maze[11] = new Line(2,4,4,4);
        maze[11].addConnection(Line.Beginning, Direction.Left, 10, Line.End);
        maze[11].addConnection(Line.Beginning, Direction.Up, 8, Line.End);
        maze[11].addConnection(Line.End, Direction.Up, 9, Line.End);
          
        scaleMaze();
    }

    // adjusts the maze coordinates to match the maze drawn
    // on the screen
    private function scaleMaze()
    {
        var nScaleX = 90;
        var nScaleY = 90;
        var nOffsetX = 50;
        var nOffsetY = 0;
        var i = 0;

        for (i = 0; i< 12; i++) {
            maze[i].x1 *= nScaleX;
            maze[i].x1 += nOffsetX;
            maze[i].x2 *= nScaleX;
            maze[i].x2 += nOffsetX;
            maze[i].y1 *= nScaleY;
            maze[i].y1 += nOffsetY;
            maze[i].y2 *= nScaleY;
            maze[i].y2 += nOffsetY;
        }
    }
}

